import { SyncAbstractDriverInterface, AsyncAbstractDriverInterface, KMap } from '../..';
import { BaseModel } from './base-model.class';
import { ModelOptionsInterface } from './model-options.interface';
export declare class CollectionModel<DataType = any, DriverType extends SyncAbstractDriverInterface | AsyncAbstractDriverInterface = AsyncAbstractDriverInterface> extends BaseModel<Record<string, DataType>, DriverType> {
    constructor(options: Partial<ModelOptionsInterface>);
    private nextPrimaryKey;
    seeded: boolean;
    _curdSubscribeFuncs: {
        insertItem: Record<number, Function>;
        setItem: Record<number, Function>;
        removeItem: Record<number, Function>;
    };
    insertItem(item: DataType): Promise<string>;
    bulkInsertItem(items: Array<DataType>): Promise<Array<string>>;
    insertItem$<Key extends keyof DataType>(closFunc: (key: Key, value: DataType[Key]) => void): () => boolean;
    all(): KMap<DataType>;
    seed(seed: Function | Array<DataType>): Promise<void>;
}
