import { BaseModel } from "./base-model.class";
export class KeyValueModel extends BaseModel {
    constructor(options) {
        super(Object.assign(Object.assign({}, options), { ioType: "sync", modelType: "keyValue" }));
        this.seeded = false;
    }
    seed(seed) {
        let seedFunc;
        if ("function" === typeof seed) {
            seedFunc = () => {
                this.seeded = true;
                seed();
            };
        }
        else if ("object" === typeof seed && !(seed instanceof Array)) {
            seedFunc = () => {
                this.seeded = true;
                for (const key in seed)
                    this.setItem(key, seed[key]);
            };
        }
        else {
            throw new Error(`[Kurimudb] In "keyValue" model, the argument to the seed function must be "Function" or "Object".`);
        }
        if (this.seeded)
            return;
        if (undefined === this.storage) {
            seedFunc();
        }
        else {
            this.storage.seeding(seedFunc);
        }
    }
}
//# sourceMappingURL=key-value-model.class.js.map